/*
 * SerialCommunication.framework for iOS
 * sample code
 * SerialCommunicationSkeletonViewController.h
 *
 * Copyright (c) Yusuke Sekikawa, 11/06/02
 * All rights reserved.
 * 
 * BSD License
 *
 * Redistribution and use in source and binary forms, with or without modification, are 
 * permitted provided that the following conditions are met:
 * - Redistributions of source code must retain the above copyright notice, this list of
 *  conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright notice, this list
 *  of conditions and the following disclaimer in the documentation and/or other materia
 * ls provided with the distribution.
 * - Neither the name of the "Yusuke Sekikawa" nor the names of its contributors may be u
 * sed to endorse or promote products derived from this software without specific prior 
 * written permission.
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY E
 * XPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES O
 * F MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SH
 * ALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENT
 * AL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROC
 * UREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS I
 * NTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRI
 * CT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF T
 * HE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#import <UIKit/UIKit.h>
#import <SerialCommunication/SerialCommunication.h>

@interface SerialCommunicationSkeletonViewController : UIViewController <SerialCommunicationDelegate>{
    IBOutlet UIImageView    *button1,*button2,*button3,*buttonJoy;
    IBOutlet UILabel        *temp,*light;
    IBOutlet UILabel        *wanAdd,*wifiAdd;
    IBOutlet UITextField    *peerAdd;
    IBOutlet UIButton       *relay1,*relay2;
    IBOutlet UIButton       *connect;
    IBOutlet UISlider       *LED1R,*LED1G,*LED1B,*LED2R,*LED2G,*LED2B,*LED3R,*LED3G,*LED3B; 
    IBOutlet UISlider       *SERVO01,*SERVO02,*SERVO03;
    
    BOOL relay1IsOn,relay2IsOn;

    
    SerialCommunication *_serialCommunication;
}
-(IBAction)relay1:(id)sender;
-(IBAction)relay2:(id)sender;
-(IBAction)sliderValChanged:(id)sender;
-(IBAction)connectToServer:(id)sender;
@end
